/*****************************************************************************
 * $Id: pyext_DequeChar.hh,v 1.1 2006-02-25 05:39:54 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	DequeChar Python extension built over C++ deque<char>.
 * @remarks 
 *//*
 * LEGAL:	COPYRIGHT (C) JIM E. BROOKS 2005
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#ifndef PYPERSRC_PYEXT_DEQUE_CHAR_HH
#define PYPERSRC_PYEXT_DEQUE_CHAR_HH 1

// DequeCharMap associates a Python instance (PyObject*) of the Python
// DequeChar class with an instance of a C++ DequeChar class (DequeChar*).
typedef deque<char> DequeChar;
typedef map<PyObject*,DequeChar*> DequeCharMap;

PyObject*
DequeChar_New( PyObject* nil, PyObject* args );

PyObject*
DequeChar_Delete( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PushHead( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PushTail( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PopHead( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PopTail( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PeekHead( PyObject* nil, PyObject* args );

PyObject*
DequeChar_PeekTail( PyObject* nil, PyObject* args );

PyObject*
DequeChar_IfEmpty( PyObject* nil, PyObject* args );

PyObject*
DequeChar_Size( PyObject* nil, PyObject* args );

PyObject*
DequeChar_Set( PyObject* nil, PyObject* args );

PyObject*
DequeChar_Get( PyObject* nil, PyObject* args );

PyObject*
DequeChar_SetItem( PyObject* nil, PyObject* args );

PyObject*
DequeChar_GetItem( PyObject* nil, PyObject* args );

PyObject*
DequeChar_Index( PyObject* nil, PyObject* args );

PyObject*
PythonStringFromDequeChar( const DequeChar* dequeChar, DequeChar::const_iterator itr, int len );

#endif // PYPERSRC_PYEXT_DEQUE_CHAR_HH
