/*****************************************************************************
 * $Id: pyext_GreedyDict.hh,v 1.1 2006-02-25 05:39:54 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	GreedyDict Python extension built over C++ GreedyMap template class.
 * @remarks GreedyDict and GreedyMap are the same concepts.
 *//*
 * LEGAL:	COPYRIGHT (C) JIM E. BROOKS 2005
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#ifndef PYPERSRC_PYEXT_GREEDY_DICT_HH
#define PYPERSRC_PYEXT_GREEDY_DICT_HH 1

#include "greedyMap.hh"

typedef GreedyMap<PyObject*> GreedyDict;
typedef map<PyObject*,GreedyDict*> GreedyDictMap;

PyObject*
GreedyDict_New( PyObject* nil, PyObject* args );

PyObject*
GreedyDict_Delete( PyObject* nil, PyObject* args );

PyObject*
GreedyDict_Insert( PyObject* nil, PyObject* args );

PyObject*
GreedyDict_Find( PyObject* nil, PyObject* args );

#endif // PYPERSRC_PYEXT_GREEDY_DICT_HH
