/*****************************************************************************
 * $Id: utils_python.hh,v 1.2 2006-02-28 14:24:37 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Utilities for writing Python extensions in C++.
 * @remarks
 *//*
 * LEGAL:	COPYRIGHT (C) JIM E. BROOKS 2006
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#ifndef UTILS_PYTHON_HH
#define UTILS_PYTHON_HH 1
namespace UtilsNS {

// -----------------------------------------------------------------------------
// Macros for Python C/API

#define PY_RETURN_NONE										\
	Py_INCREF(Py_None);										\
	return Py_None;

#define PY_RETURN_INDEX_ERROR								\
	PyErr_SetString( PyExc_IndexError, "index error" );		\
	return NULL;

#define PY_RETURN_BAD_OBJECT_ERROR							\
	PyErr_SetString( PyExc_TypeError, "bad object" );		\
	return NULL;

} // namespace UtilsNS
#endif // UTILS_PYTHON_HH
