/*****************************************************************************
 * $Id: utils_string.hh,v 1.2 2006-02-28 14:24:37 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Utility string functions.
 * @remarks
 *//*
 * LEGAL:	COPYRIGHT (C) JIM E. BROOKS 2006
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#ifndef UTILS_STRING_HH
#define UTILS_STRING_HH 1
namespace UtilsNS {

const char*
Find( const char* haystack, const char* needle, bool caseSens, int& line );

/*****************************************************************************
 * Return pointer to char after newline (assumes null-terminated string).
 * Could point to null char.
 *****************************************************************************/
static inline const char*
MovePastNewLine( const char* pc )
{
    for ( ; *pc != '\n' && *pc != '\0'; ++pc ) { }
    return pc;
}

/*****************************************************************************
 * Convert a C string to lower-case as a C++ string.
 *****************************************************************************/
static inline void
StringLowercase( const char* in, string& out )
{
    out.erase();
    for ( ; *in; ++in ) out += char(tolower(*in));    // char-by-char
}

} // namespace UtilsNS
#endif // UTILS_STRING_HH
