/*****************************************************************************
 * Author:  Jim Brooks.
 * Date:    2006/01
 * ctags interface exported to pypersrc.
 * pypersrc tells ctags which files to tag, then ctags passes the tags to callback.
 *****************************************************************************/

#ifndef CTAGS_IFC_H
#define CTAGS_IFC_H 1
#ifdef __cplusplus
extern "C" {
#endif

/*
 * For passing a tag to a callback registered by pypersrc.
 */
typedef struct
{
    const char* nameStr;
    const char* typeStr;
    const char* fileStr;
    int         lineNum;
} Extag; /* exuberant tag */

/*
 * Callbacks.
 */
typedef void (*CTAGS_TAG_CALLBACK)( const Extag* );
extern CTAGS_TAG_CALLBACK gCtagsTagCallback;        /* called when ctags has parsed a tag */

/*
 * ctags function interface.
 */
extern int CtagsTagFile( const char* filename, CTAGS_TAG_CALLBACK ctagsTagCallback );
extern int CtagsStart( int argc, char** argv );
extern void CtagsEnd( void );


#ifdef __cplusplus
}
#endif
#endif /* CTAGS_IFC_H */
