# $LastChangedDate: 2009-09-14 11:37:11 -0500 (Mon, 14 Sep 2009) $
# Test.
#===============================================================================

import sys
sys.path.append( "." )
sys.path.append( "src/py" )
sys.path.append( "../src/py" )
#from base_funcs import *
from lib import *

#-------------------------------------------------------------------------------
# Test Unique()
#-------------------------------------------------------------------------------

print( "Test Unique()" )

# Unique() returns a sequence type in UNDEFINED ORDER so sort if possible.

l = [ "a", "a", "b", "c" ]
l2 = Unique( l )
l2.sort()
assert( len(l2) == 3 )
assert( l2[0] == "a" )
assert( l2[1] == "b" )
assert( l2[2] == "c" )

class Object:
    pass
obj0 = Object()
obj1 = Object()
obj2 = Object()
l = [ obj0, obj1, obj1, obj1, obj2, obj2, obj0 ]
l2 = Unique( l )
#l2.sort()
assert( len(l2) == 3 )
assert( obj0 in l2 )
assert( obj1 in l2 )
assert( obj2 in l2 )

# Is unique already.
l = [ "b", "a" ]
l2 = Unique( l )
l2.sort()
assert( len(l2) == 2 )
assert( l2[0] == "a" )
assert( l2[1] == "b" )

# Is unique already.
l = [ "z" ]
l2 = Unique( l )
l2.sort()
assert( len(l2) == 1 )
assert( l2[0] == "z" )

# Empty case.
l = [ ]
l2 = Unique( l )
l2.sort()
assert( len(l2) == 0 )

#-------------------------------------------------------------------------------
# Test List2String.
#-------------------------------------------------------------------------------

print( "Test List2String()" )

s = List2String( [ "a", "b", "c" ] )
assert( len(s) == 3 )
assert( s == "abc" )

#-------------------------------------------------------------------------------
# Test DeleteFromList().
#-------------------------------------------------------------------------------

print( "Test DeleteFromList()" )

def DeleteFromListFunctor( elem ):
    return elem == 999
l = [ 123, 456, 999, 789 ]
DeleteFromList( l, DeleteFromListFunctor )  # keeps order
assert( len(l) == 3 )
assert( l[0] == 123 )
assert( l[1] == 456 )
assert( l[2] == 789 )

#-------------------------------------------------------------------------------
# Test DeleteFromDict().
#-------------------------------------------------------------------------------

print( "Test DeleteFromDict()" )

def DeleteFromDictFunctor( key ):
    # Test key (not value).
    return key == "z"
d = { "a":123, "b":456, "c": 789, "z":-9 }
DeleteFromDict( d, DeleteFromDictFunctor )  # undefined order
assert( len(d) == 3 )
assert( ("a" in d) and (d["a"] == 123) )
assert( ("b" in d) and (d["b"] == 456) )
assert( ("c" in d) and (d["c"] == 789) )
assert( not ("z" in d) )

# Missing key case.
d = { "a":123, "b":456, "c": 789 }
DeleteFromDict( d, DeleteFromDictFunctor )  # undefined order
assert( len(d) == 3 )
assert( ("a" in d) and (d["a"] == 123) )
assert( ("b" in d) and (d["b"] == 456) )
assert( ("c" in d) and (d["c"] == 789) )
assert( not ("z" in d) )

# Single element case.
d = { "z":-9 }
DeleteFromDict( d, DeleteFromDictFunctor )  # undefined order
assert( len(d) == 0 )
assert( not ("z" in d) )

# Empty dict case.
d = { }
DeleteFromDict( d, DeleteFromDictFunctor )  # undefined order
assert( len(d) == 0 )
assert( not ("z" in d) )

#-------------------------------------------------------------------------------
# Passed.
#-------------------------------------------------------------------------------

print( "Test passed (ok)!" )
sys.exit( 0 )
